#include "huc.h"

#define MIN_TRACK 1
#define MAX_TRACK 6

#define FNC_PLYTRK 1
#define FNC_PAUSE 2
#define FNC_UNPAUSE 3
#define FNC_RESET 4
#define FNC_FADE  5
#define FNC_REREAD 6


main()
{
   static int y_pos, i, numtrk, trktype, readcd;
   static int track, joyrd, joy_func, retval, playtype, fadetype;
   int fadeval[5];

   fadeval[0] = CDFADE_CANCEL;
   fadeval[1] = CDFADE_PCM6;
   fadeval[2] = CDFADE_ADPCM6;
   fadeval[3] = CDFADE_PCM2;
   fadeval[4] = CDFADE_ADPCM2;

   set_color(0,0);
   set_color(1,511);

   set_xres(320);

   playtype = CDPLAY_MUTE;
   fadetype = 1;
   retval = 0;

   y_pos = 1;
   track = 1;
   joy_func = 1;

   put_string("CDROM System Card Tests", 5, y_pos); 

   y_pos = 3;


   put_string("Version:", 2, y_pos); 
   put_hex(cd_getver(), 4, 11, y_pos);

   put_string("Arcade Card:", 20, y_pos);
   put_hex(ac_exists(), 2, 35, y_pos);

   readcd = 1;

   mouse_disable();

   while (1)
   {

     joyrd = joytrg(0);

     if (readcd == 1)
     {
        y_pos = 4;

        numtrk = cd_numtrk();
        put_string("CD tracks:", 2, y_pos);
        put_number(numtrk, 2, 13, y_pos);

        if (numtrk > 0)
        {
           put_string("Track ", 20, 4);
        }
        for (i = 1; i < 25; i++)
        {
           if (i < numtrk+1)
           {
              put_string("type: ", 29, i+3);
              put_number(i, 2, 26, i+3);
              trktype = cd_trktype(i);
                 put_hex(trktype, 4, 35, i+3);
/*
              if (trktype == CDTRK_AUDIO)
              {
                 put_string("AUDIO", 35, i+3);
              }
              else if (trktype == CDTRK_DATA)
              {
                 put_string("DATA", 35, i+3);
              }
*/
           }
           else
           {
              put_string("            ", 29, i+3);
           }
        } 
        readcd = 0;
     }

     switch(joy_func) {

        case FNC_PLYTRK:
           if ((joyrd & JOY_RGHT) && (track < MAX_TRACK)) {
              track++;
           }

           if ((joyrd & JOY_LEFT) && (track > MIN_TRACK)) {
              track--;
           }

           if (joyrd & JOY_DOWN) {
              joy_func++;
           }

           if (joyrd & JOY_SLCT) {
              playtype++;
              if (playtype > CDPLAY_NORMAL) {
                 playtype = CDPLAY_MUTE;
              }
           }

           if (joyrd & JOY_STRT) {
              if (track != MAX_TRACK) {
                 retval = cd_playtrk(track, track+1, playtype);
              } else {
                 retval = cd_playtrk(track, CDPLAY_ENDOFDISC, playtype);
              }
           }
           break;

        case FNC_PAUSE:
           if (joyrd & JOY_UP) {
              joy_func--;
           }
           if (joyrd & JOY_DOWN) {
              joy_func++;
           }
           if (joyrd & JOY_STRT) {
              retval = cd_pause();
           }
           break;

	case FNC_UNPAUSE:
           if (joyrd & JOY_UP) {
              joy_func--;
           }
           if (joyrd & JOY_DOWN) {
              joy_func++;
           }
           if (joyrd & JOY_STRT) {
              retval = cd_unpause();
           }
           break;

        case FNC_RESET:
           if (joyrd & JOY_UP) {
              joy_func--;
           }
           if (joyrd & JOY_DOWN) {
              joy_func++;
           }
           if (joyrd & JOY_STRT) {
              retval = cd_reset();
           }
           break;

        case FNC_FADE:
           if (joyrd & JOY_UP) {
              joy_func--;
           }
           if (joyrd & JOY_DOWN) {
              joy_func++;
           }
           if (joyrd & JOY_SLCT) {
              fadetype++;
              if (fadetype > 4) {
                 fadetype = 0;
              }
           }

           if (joyrd & JOY_STRT) {
              retval = cd_fade(fadeval[fadetype]);
           }
           break;

        case FNC_REREAD:
           if (joyrd & JOY_UP) {
              joy_func--;
           }
           if (joyrd & JOY_STRT) {
              readcd = 1;
           }
           break;
     }


     /* PLAY TRACK SECTION */

     y_pos = 7;

     if (joy_func == FNC_PLYTRK) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Play Track #:", 2, y_pos);
     put_hex(track, 2, 16, y_pos);

     switch (playtype) {
        case CDPLAY_MUTE:
           put_string("MUTE  ", 19, y_pos);
           break;
        case CDPLAY_REPEAT:
           put_string("REPEAT", 19, y_pos);
           break;
        case CDPLAY_NORMAL:
           put_string("NORMAL", 19, y_pos);
           break;
        default:
           put_string("      ", 19, y_pos);
           break;
     }


     /* PAUSE CDROM SECTION */

     y_pos = 8;

     if (joy_func == FNC_PAUSE) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Pause CDROM", 2, y_pos);


     /* UNPAUSE CDROM SECTION */

     y_pos = 9;

     if (joy_func == FNC_UNPAUSE) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Unpause CDROM", 2, y_pos);


     /* RESET CDROM SECTION */

     y_pos = 11;

     if (joy_func == FNC_RESET) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Reset CDROM", 2, y_pos);


     /* FADE AUDIO SECTION */

     y_pos = 13;

     if (joy_func == FNC_FADE) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Fade:", 2, y_pos);

     switch (fadetype) {
        case 0:
           put_string("CANCEL FADE  ", 9, y_pos);
           break;
        case 1:
           put_string("PCM 6 sec    ", 9, y_pos);
           break;
        case 2:
           put_string("ADPCM 6 sec  ", 9, y_pos);
           break;
        case 3:
           put_string("PCM 2.5 sec  ", 9, y_pos);
           break;
        case 4:
           put_string("ADPCM 2.5 sec", 9, y_pos);
           break;
        default:
           put_string("ADPCM 2.5 sec", 9, y_pos);
           break;
     }


     /* FADE AUDIO SECTION */

     y_pos = 15;

     if (joy_func == FNC_REREAD) {
        put_string("x", 0, y_pos);
     } else {
        put_string(" ", 0, y_pos);
     }

     put_string("Reread CD contents", 2, y_pos);


     /* COMMON STUFF SECTION */

     y_pos = 18;
     put_string("retval:", 2, y_pos);
     put_hex(retval, 4, 10, y_pos);

     vsync(0);
   }

   return;
}

